#!/usr/bin/perl -w

 #######################################################################
 # Copyright 2007-2009 Igor Daniloff.
 # 
 # Following source code is the property of Doctor Web, Ltd.
 # Use is subject to license terms.
 # The reproduction in any form without written permission of
 # Doctor Web, Ltd. and proper attribution is strongly prohibited.
 #######################################################################

package dwconfig;
use Exporter;
@ISA     = qw(Exporter);

@EXPORT = qw(IsSmtp IsCgp IsExim IsQmail IsZmailer IsPostfix IsCourier
IsSendmail IsMailDesk DwInit DwEnterString DwEnterPsswd DwModify DwGetValue %lng DwLoadFile
DwSaveFile DwDebug DwInitInit DwEnterConfig UseMilter DwSaveConf
DwHaveValidKey GetProductName GetProductMonitorName DwBackup DwCopyFile DwPatchAmcFileParam);

$VERSION = 1.00;

$SIGN_READER = '/opt/drweb/read_signed';

$debug=0;

sub IsSmtp{return 0;}
sub IsCgp{return 1;}
sub IsExim{return 0;}
sub IsQmail{return 0;}
sub IsZmailer{return 0;}
sub IsPostfix{return 0;}
sub IsCourier{return 0;}
sub IsSendmail{return 0;}
sub IsMailDesk{return 0;}
sub GetProductName(){ return 'maild';}
sub GetProductMonitorName(){ return 'MAILD';}

sub UseMilter{return IsSendmail() || IsPostfix();}


sub DwDebug
{
    print "@_\n" if $debug;
}

sub DwGetConfFile
{
    return "drweb_maildesk.conf" if IsMailDesk(); # befor IsSmtp()!
    return "maild_smtp.conf" if IsSmtp();
    return "maild_sendmail.conf" if IsSendmail();
    return "maild_postfix.conf" if IsPostfix();
    return "maild_exim.conf" if IsExim();
    return "maild_qmail.conf" if IsQmail();
    return "maild_cgp.conf" if IsCgp();
    return "maild_zmailer.conf" if IsZmailer();
    return "maild_courier.conf" if IsCourier();
    die "DwGetConfFile\n";
}

%lng=('Hostname' =>'Enter hostname.',
      'AdminMail' =>'Enter email address to send notifications to.',
      'FilterMail' =>'Enter email address to send notifications from.',
      'BeforeQueueFilters'=>'Enter list of plugins to process message before placing it to queue/DB.',
      'AfterQueueFilters'=>'Enter list of plugins to process message after placing it to queue/DB.',
      'ProtectedNetworks'=>'Enter list of protected networks (e.g. 127.0.0.0/8).',
      'ProtectedDomains'=>'Enter list of protected domains.',
      'ReceiverAddress'=>"Enter MailD address(es) to handle SMTP/LMTP requests. Valid types: inet, local.",
      'SecureHash'=>'Enter contents for SecureHash header.',
      'SenderAddress'=>"Enter email address for outgoing messages. Valid types: inet, local, mx.",
      'NotifyLangs'=>'Enter language(s) to use in reports.',

      'Key'=>'Enter path to key file for Dr.Web MailD.
If you don\'t have the key yet you can leave this value unspecified,
but you must set LicenseFile parameter value in configuration file agent.conf,
and parameter Key in configuration file drweb32.ini before MailD is
launched or any plugin is installed.',

      'PluginKey'=>'Enter path to key file with %s plugin support.
If you don\'t have the key yet you can leave this value unspecified,
but you must set LicenseFile parameter value in configuration file (agent.conf)
before MailD is launched or any plugin is installed.',
      'key_not_exists'=>'"%s": No such file or directory. You should use another key file with
Dr.Web MailD support.',
      'wrong_Key' => '"%s": Key file is wrong. You should use another key file with
Dr.Web MailD support.',
      'wrong_plugin_Key'=>'Wrong key file %s. You should use another key file with
%s plugin support.',

      'AddedPlugin_l' => 'Queue %s = %s',

      'Hostname_l' =>'Hostname',
      'AdminMail_l' =>'Administrator email address',
      'FilterMail_l' =>'Filter email address',
      'BeforeQueueFilters_l'=>'Before queue plugins',
      'AfterQueueFilters_l'=>'After queue plugins',
      'ProtectedNetworks_l'=>'Protected networks',
      'ProtectedDomains_l'=>'Protected domains',
      'ReceiverAddress_l'=>"Receiver email address(es)",
      'SecureHash_l'=>'Secure hash',
      'SenderAddress_l'=>"Sender email address(es)",
      'NotifyLangs_l'=>'Language(s) for reports',
      'lng_dir_l' =>'lng files directory',
      'plugins_dir_l' =>'Plugins directory',

      'Key_l'=>'Path to key file for Agent',
      'DaemonKey_l' =>'Path to key file for Dr.Web Daemon',
      'ScannerKey_l'=>'Path to key file for Dr.Web Scanner',

      'wrong_exist'=>"Info: %s.drwebsave exists. Saving %s as %s.",
      'wrong_addr'=>'ERROR: wrong address entered: "%s".
Address should be "local:/path/to/file", "inet:port@host" or "pid:/path/to/pidfile".',
      'wrong_pid'=>'ERROR: cannot read from "%s" pid-file.',
      'no_changes'=>'Cannot find new data to add.',
      'lng_dir' =>'Enter path to localization files directory.',
      'conf_dir' => 'Enter path to Dr.Web configuration files directory.',
      'err_conf_dir' => 'Cannot find configuration file %s in %s directory.',
      'plugins_dir' =>'Enter path to plugins directory.',
      'read_error' =>'ERROR: cannot open for reading.',
      'write_error'=>'ERROR: cannot open for writing.',
      'dir_error'=>'ERROR: "%s" is not a directory.',
      'copy_error'=>'failed to copy %s to %s.',
      'move_error'=>'failed to move %s to %s.',
      'chown_error' => 'ERROR: failed to change user and group for file %s on %s:%s.',
      'chmod_error' => 'ERROR: failed to set rules %s for file %s.',
      'wrong_plugin_name'=>'ERROR: unrecognized plugin name "%s".',
      'plugin_already_used' => 'ERROR: plugin "%s" is already in use!',
      'wrong_lng_name'=>'ERROR: unrecognized language name "%s".',
      'ok_patch'=>'patched OK.',
      'vector_value'=>'Values are delimited with commas.',
      'possible_values'=>"Possible values: ",
      'wait_number'=>'ERROR: wrong "wait number" value entered.',
      'invalid_option'=>'ERROR: invalid option.',
      'question'=>'Press 1 to Save updated configuration,
2 to go Back to editing, 3 to Cancel or 5 to Redisplay [1]',
      'question_migrate'=>q'
============
Parameter %s
      default value: %s
      old     value: %s
Press 1 to Update parameter, 3 to Skip, 5 to Update ALL parameters or 7 to Exit [1] ',
      'migrate_introduction'=>q'
This script converts parameters from old configuration files:

%s
to new configuration files:

%s

Continue (y/n) [y] ? ',
      'install_new_configs'=>q'
Install new configuration files from

%s

to

%s

Install (y/n) [y] ? ',
      'default'   =>'default',
      'config'=>'Configuration',
      'unrecognize_params'=>'Unrecognizable parameters: ',
      'restart'=>'drweb-maild successfully reloaded',
      'monitor_restart'=>'drweb-monitor successfully restarted',
      'modif_section'=>q'

=============================
Strings for adding in section [%s]:

%s

Add these strings to file %s? [y/n] ',
      'num_params'=>'Successfully updated %i parameters',

      'wrong_version'=>q(Wrong version '%s'),
      'wrong_line'=>q(Unrecognizable line '%s'),

      'ur_wrong_params'=>q(Please use '%s path/to/users.conf
path/to/maild_conf'),

      'ar_wrong_params'=>q(Please use '%s path/to/addresses.conf path/to/maild_conf'),

      'vr_wrong_params'=>q(Please use '%s path/to/viruses.conf path/to/maild_conf'),

      'rules_wrong_params'=>q(Please use '%s path/to/old_maild_conf path/to/new_maild_conf'),

      'pc_before'=>'Add plugin to processing before moving message to queue/DB (y/n) ?',
      'pc_after'=>'Add plugin to processing after moving message to queue/DB (y/n) ?',
      'pc_add'=>'Add plugin to %s. Messages will be scanned by the plug-ins in an order, which is specified for the plug-ins in the settings.',
      'pc_question_b'=>'Press 1 to insert plugin "%s" before "%s", ',
      'pc_question_a'=>'Press 1 to insert plugin "%s" after "%s", ',
      'pc_question_l'=>'Press 3 to move left, ',
      'pc_question_r'=>'Press 5 to move right, ',
      'pc_question_e'=>'Press 7 to skip.',
      'pc_patched'=>'Plugin %s is already added to Dr.Web MailD configuration file.',

      'email_address'=>'Enter e-mail address to protect (empty string to stop input).',
      
      'install_key'=>'Success installing key-file from %s to %s',
      'modif_rules'=>q'

=============================
New rules from old configuration file
%s:

%s

Add these rules to file %s? [y/n] ',
      'old_rules_default'=>'Rules from old configuration file not changed -> skip rules migration.',

      'daemon_path'       => 'Enter path to MailD for web-interface.',
      'ini_file'          => 'Enter path to ini-file of MailD for web-interface.',
      'init_script'       => 'Enter path to init-script of monitor for web-interface.',
      'drweb_inject'      => 'Enter path to drweb-inject for web-interface.',
      'admin_password'    => 'Enter password for admin for web-interface',
      'empty_password'    => 'Password is empty. Try again.',
      'repeat'            => 'Repeat password for admin web-interface, please',
      'unequal_password'  => 'Passwords is not equal. Try again.',
      'web_interface_lng' => 'Enter language for web-interface.',
      'web_server_user'   => 'Enter needed web-server user or empty string to add user \'drweb\' into correct web-server group manually.',

      'daemon_path_l'        => 'Path to MailD for web-interface',
      'ini_file_l'           => 'Path to ini-file of MailD for web-interface',
      'init_script_l'        => 'Path to init-script of monitor for web-interface',
      'drweb_inject_l'       => 'Path to drweb-inject for web-interface',
      'admin_password_l'     => 'Password for admin for web-interface',
      'admin_email_l'        => 'Web-interface admin\'s login',
      'web_interface_lng_l'  => 'Language for web-interface',
      'web_server_user_l'    => 'Web-server user',
      'web_server_empty_val' => 'Not defined yet (do not forget to add user \'drweb\' into correct web-server group manually)',

      'founded_webserver_users' => 'Founded following web-server users: ',

      'file_name_err' => 'Wrong filename',
      'file_exist_err' => 'File \'%s\' does not exist',
      'add_user_to_group_err' => 'Error: Can not add \'%s\' user to group \'%s\'!',
      'echo_mode_on_err' => 'Error: Can not switch on echo mode.',
      'echo_mode_off_err' => 'Error: Can not switch off echo mode.',

      'empty_web_server_user_warn' => 'You did not define web-server\'s user, do not forget to add user \'drweb\' into correct web-server\'s group manually!',
      'uncknown_user_warn' => 'User \'%s\' is not exists'.".\n",

      'allready_in_group' => "User \'%s\' is already in group \'%s\'. Skipping...\n",

      ''=>''
    ); 

######################################################################
sub DwEnterString
{
    my ($descr,$value,$add) = @_;
    print "\n";
    print ($lng{$descr} or $descr);
    print $add if $add;
    print "\n [".$lng{'default'}."=".$$value."]:";
    my $val = <>;
    chomp $val;
    $$value = $val if $val ne "";
}

######################################################################
sub DwEnterPsswd
{
    my ($descr,$value) = @_;
    print "\n";
    print ($lng{$descr} or $descr);
    print ":";
    system("stty -echo") == 0
        or die (sprintf $lng{'echo_mode_off_err'},$group_name, $user_name);
    my $val = <>;
    chomp $val;
    print "\n";
    system("stty echo") == 0
        or die (sprintf $lng{'echo_mode_on_err'},$group_name, $user_name);
    $$value = $val if $val ne "";
}
######################################################################
sub DwReadSign
{
    my ($mode, $file) = @_;

    if (!-e $SIGN_READER) {
        DwDebug "Seems that read_signed is not installed, trust you that file is ok.";
        return 1;
    }

    my $cmd = "\"$SIGN_READER\" $mode \"$file\"";
    if( !open(FH, "$cmd 2>&1 |") ) {
        die "error during executing: $cmd ($!)";
    }
    if( !close FH ) {
        DwDebug(
             $! ? "exec($cmd) closes pipe with status: $!"
                : "exec($cmd) exits with error #".($?>>8)
           );
        return 0;
    }
    return 1;
}

######################################################################
sub DwHaveValidKey
{
    my ($KeyFile,$regex) = @_;
    DwDebug "\nSearch key in $KeyFile.";
    foreach my $file ( map{/^\s*(.+)\s*$/} split(",",$KeyFile)){
        if ( -f $file && -r $file ){
            if (!&DwReadSign('key', $file)) {
                DwDebug "Key file '$file' does not have valid signature.";
                return 0;
            }
            my $body = DwLoadFile($file);
            my ($app_existense_flag,$expired_date_existense_flag,$expired_flag);
            foreach my $line (split /\n/,$body) {
                if($line =~ /$regex/i){
                    DwDebug "File $file have '$regex' in body.";
                    $app_existense_flag=1;
                } elsif ($line=~/^Expires=(\d{4})-(\d{2})-(\d{2})\s\((\d{2}):(\d{2})\)\sUTC/i) {
                    $expired_date_existense_flag=1;
                    my $gmtime = $1.$2.$3.$4.$5;
                    my (undef, $min, $hour, $day, $mon, $year) = gmtime();
                    $year+=1900;
                    $mon++;
                    ($mon, $day, $hour, $min) = map {$_<10?"0$_":$_} ($mon, $day, $hour, $min);
                    if ($gmtime<$year.$mon.$day.$hour.$min) {      
                        $expired_flag=1;
                    }
                }
                last if $expired_date_existense_flag && $app_existense_flag;
            }
            if (!$app_existense_flag) {
                DwDebug "Can not find '$regex' in file $file.";
                return 0;
            } elsif (!$expired_date_existense_flag) {
                DwDebug "Can not find expired date in file $file.";
                return 0;
            } elsif ($expired_flag) {
                DwDebug "Key $file is expired.";
                return 0;
            }
            return 1;
        }else{
            DwDebug "Can not read file $file";
            return 0;
        }
    }
    DwDebug "No valid key find in $KeyFile.";
    return 0;
}
######################################################################
sub ToOneString
{
    my ($modif,$param) = @_;
    my $res="";
    while($param && $modif =~ /^([ \t]*$param[ \t]*=[ \t]*(.*?)\\)$/mgci){
        $res .= substr($modif,0,pos($modif)-length($1))."$param = ".$2;
        DwDebug "PARAM: $param = ".$2;
        while($modif =~ /\G\s*?^(?-s)(.*?)\\$/mgcis){
            my $str=$1;
            $str =~ s/^\s*/ /;
            $res.= $str;
            DwDebug "str1='$str'";
        }
        if ($modif =~ /\G\s*?^(?-s)(.*?)$/mgcis){
            my $str=$1;
            $str =~ s/^\s*/ /;
            $res.= $str;
            DwDebug "str='$str'";
        }
    }
    $res.=$1 if $modif =~ /\G(.*)/mgcis;
    return $res;
}
######################################################################
sub DwModify
{
    my ($file,$section,$param,$val,$type) = @_;

    if ($type eq 'multi_string' && defined $param) {
       $val = [split '\s*,\s*', $val]
           if ref $val ne 'ARRAY';
       foreach (@{$val}) {
           if(/\s/){
                s/"/\\"/g;
                $_="\"$_\"";
           }
       }

       my $find_flag = 0;
       my $index     = 0;
       my @new_lines = ();
       my @lines     = split "\n", $file;
       my $lines_num = scalar @lines;
       EXT_LOOP:for(;$index<$lines_num;$index++) {
           if ($lines[$index] =~ /^\s*\[[ \t]*$section[ \t]*\]/i) {
               push @new_lines, $lines[$index];
               INT_LOOP:for($index++;$index<$lines_num;$index++) {
                   if ( $lines[$index] =~ /^\s*\[[ \t]*\S+[ \t]*\]/       &&
                        $lines[$index] !~ /^\s*\[[ \t]*$section[ \t]*\]/i) {
                       unless ($find_flag) {
                           $find_flag++;
                           foreach (@$val) {
                               push @new_lines, "$param=$_";
                           }
                       }
                       last INT_LOOP;
                   }
                   if ($lines[$index] =~ /^\s*$param\s*=/i) {
                       unless ($find_flag) {
                           $find_flag++;
                           foreach (@$val) {
                               push @new_lines, "$param=$_";
                           }
                       }
                   } else {
                       push @new_lines, $lines[$index];
                   }
               }
               last EXT_LOOP if $index > $lines_num;
           }
           push @new_lines, $lines[$index];
       }

       unless ($find_flag) {
           foreach (@$val) {
               push @new_lines, "$param=$_";
           }
       }

       $file = join "\n", @new_lines;
       $val  = join ', ', @{$val};
    } else {
        if($type eq "string" && $val =~ /\s/){
            $val=~s/"/\\"/g;
            $val="\"$val\"";
        }
        my ($prev,$modif,$next)=("","","");
        if($file =~ /^\s*\[[ \t]*$section[ \t]*\](?-s)(?:(?:[ \t]*#.*)|(?:[ \t]*;.*)|[ \t]*)$/mgi){
            $prev = substr $file, 0, pos($file);
            if($file =~ /\G(.*?)(^\s*\[[ \t]*(.*?)[ \t]*\](?-s)(?:(?:[ \t]*#.*)|(?:[ \t]*;.*)|[ \t]*))$/mgcis){
                DwDebug "Find section: $section ".($3?"(next: $3)":"").($param?" -> seaching param $param...":"");
                $modif = $1;
                $next  = $2.substr($file,pos($file));
            }else{
                DwDebug "Find section: $section (last in file)".($param?" -> seaching param $param...":"");
                $modif = substr $file, pos($file);
            }
            if(!$param){
                $modif = $val;
            }else{
                #change $modif
                $modif = ToOneString($modif,$param);

                if($modif =~ /((?s:.*?)^[ \t]*$param[ \t]*=[ \t]*)(.*?)((?:[ \t]*#.*?)|(?:[ \t];.*?)|[ \t]*)$/mgci){
                    DwDebug "Find value: $param = '$2' 3='$3'";
                    my $length = length($1)+length($2)+length($3);
                    my $start = pos($modif)-$length;
                    my $before=$1;my $after=$3;
                    DwDebug "length=$length start=$start";
                    my $rest = substr $modif,pos($modif),length($modif),"";
                    $rest =~ s/(.*?^)(?-s)([ \t]*$param[ \t]*=[ \t]*(.*?)(?:(?:[ \t]*#.*)|(?:[ \t]*;.*)|[ \t]*))$/$1/mgi;
                    $after=" ".$after unless $after =~ /^\s/;
                    substr $modif, $start, $length, $before.$val.$after.$rest;
                }else{
                    $modif = "\n$param = $val\n".$modif;
                }
            }
        }else{
            $modif=$file."\n[$section]\n\n$param = $val\n" if $param;
            $modif=$file."\n[$section]\n\n$val\n" unless $param;
        }

        $file = $prev.$modif.$next
    }
    print "$section/$param = $val\n" if $param;
    return $file;
}
######################################################################
sub DwGetValue
{
    my ($file,$section,$param,$default,$type,$delim) = @_;
    $delim = "=" unless $delim;
    my $modif;
    if($file =~ /^\s*\[[ \t]*$section[ \t]*\](?-s)(?:(?:[ \t]*#.*)|(?:[ \t]*;.*)|[ \t]*)$/mgi){
        if($file =~ /\G(.*?)(^\s*\[[ \t]*(.*?)[ \t]*\](?-s)(?:(?:[ \t]*#.*)|(?:[ \t]*;.*)|[ \t]*))$/mgcis){
            $modif = $1;
        }else{
            $modif = substr $file, pos($file);
        }
        #change $modif
        $modif = ToOneString($modif,$param);
        return $modif if !$param;
        my $res;
        while($modif =~ /^[ \t]*$param[ \t]*$delim[ \t]*(.*?)(?-s)(?:(?:[ \t]*#.*)|(?:[ \t]*;.*)|[ \t]*)$/mgcis){
            $res.=", " if $res;
            $res.=$1;
        }
        DwDebug "FIND: $section/$param".(defined($type)?" ($type)":"")." = ".(defined($res)?$res:$default);
        if ( $res && $type && $type eq "string"){
            $res =~ s/^"(.*)"$/$1/;
        }
        return defined($res)?$res:$default;
    }
    return $default;
}
######################################################################
sub DwLoadFile
{
    my $name = shift @_;
    open (DRWEBCONF,"$name") 
        or die $lng{'read_error'}." $name: $!\n";
    local $/;
    undef $/;
    $file = <DRWEBCONF>;
    close DRWEBCONF;
    return $file;
}
######################################################################
sub DwSaveFile
{
    my ($file,$body,$set_user,$rules) = @_;
    open (DRWEBCONF,">$file.__new")
        or die $lng{'write_error'}."$file\n";
    print DRWEBCONF $body;
    close DRWEBCONF;
    system("mv $file.__new $file")==0
        or die (sprintf $lng{'move_error'},"$file.__new",$file);
    if ($set_user) {
        system("chown drweb:drweb $file")==0
            or die (sprintf $lng{'chown_error'}, $file, "drweb", "drweb");
    }
    if (defined $rules) {
        system("chmod $rules $file")==0
            or die (sprintf $lng{'chmod_error'}, $rules, $file);
    }
}
######################################################################
sub DwInit
{
    my $dw_root_path=$ENV{'DW_ROOT_PATH'} || "";
    DwDebug "DW_ROOT_PATH = $dw_root_path";
    my $dw_bin_dir = "$dw_root_path/opt/drweb";
    my $dw_etc_dir = "$dw_root_path/etc/drweb";
    if ($^O=~/BSD/i) {
        $dw_bin_dir = "$dw_root_path/usr/local/drweb";
        $dw_etc_dir = "$dw_root_path/usr/local/etc/drweb";
    }
    my $dw_conf_file =DwGetConfFile();

    return ($dw_root_path,$dw_bin_dir,$dw_etc_dir,$dw_conf_file);
}

sub DwInitInit
{
    my $dw_root_path=$ENV{'DW_ROOT_PATH'} || "";
    DwDebug "DW_ROOT_PATH = $dw_root_path";
    my $dw_monitor_init = "$dw_root_path/etc/init.d/drweb-monitor";
    if ($^O=~/BSD/i) {
	$dw_monitor_init = "$dw_root_path/usr/local/etc/rc.d/00.drweb-monitor.sh";
    }
    return $dw_monitor_init;
}
######################################################################
sub DwEnterConfig
{
    my ($enter,$change_list_ref) = @_;
  REENTER:
    $enter->();
  REDISPLAY:
    print "\n\n==============\n".$lng{'config'}.":\n\n";
    for (@${$change_list_ref}) {
        print;print "\n";
    }
  QUESTION:
    print "\n".$lng{'question'}."\n";
    $confirm = <>; chomp $confirm; 
    goto REDISPLAY if $confirm eq "5";
    goto REENTER if $confirm eq "2";
    exit 1 if  $confirm eq "3";
    unless($confirm eq "" || $confirm eq "1"){
        print $lng{'invalid_option'}."\n";
        goto QUESTION;
    }
}
######################################################################
sub DwBackup
{
    my ($name) = @_;

    my $backup_filename = "$name.drwebsave";
    if( -f $backup_filename){
        my $timestamp = `date +%Y%m%d_%H-%M-%S`;
        chomp($timestamp);
        $backup_filename = "$name.$timestamp";
        print sprintf($lng{'wrong_exist'}."\n",$name,$name,$backup_filename);
    }

    system("cp $name $backup_filename")==0
            or die (sprintf $lng{'copy_error'},$name,$backup_filename);
    system("chown drweb:drweb $backup_filename") == 0
        or die (sprintf $lng{'chown_error'},$backup_filename,"drweb","drweb");

    return 1;
}
#####################################################################
sub DwSaveConf
{
    my ($name,$data) = @_;
    
    DwBackup($name);
    DwSaveFile("$name",$data,1,664);
    print "\n$name ".$lng{'ok_patch'}."\n";
}
#####################################################################
sub DwCopyFile
{
    my ($from, $to) = @_;
    system("cp $from $to && chmod 0644 $to && chown drweb:drweb $to") == 0
        or die ((sprintf $lng{'copy_error'},$from,$to).": ".$!);
    return 1;
}
#####################################################################
sub DwPatchAmcFileParam
{
    my ($file_path,$name,$from,$to) = @_;
    unless (-e $file_path) {return};

    open(FH, '<', $file_path) or die $lng{'read_error'}." $file_path: $!\n";
    my ($content, $str) = ('',undef);
    while (defined($str=<FH>)) {
       if ($str=~/^(\s*)($name)(\s*)$from/i) {
           $content .= "$1$2$3$to\n";
       } else {
           $content .= $str;
       }
    }
    close(FH);

    &DwSaveFile($file_path,$content,1,644);

    print "\n$file_path ".$lng{'ok_patch'}."\n";
    return 1;
}
#####################################################################
1;

